from itertools import count
from __agrupar import agrupar
from __aplicarUps import aplicarUps
from __ceil_raiz import ceil_raiz
from __composicion_irrestricta import composicion_irrestricta
from __hashA import hashA
from __mixradix import mixradix
from __separar import separar
from __truncar import truncar


def crearfuncion_verificar (bits, grupo, t, split, calcular_udm, upbits):

	upbytes = (upbits + 7) // 8

	def verificar (mensaje, firma=b'', sal=b'', pub=b''):
		mensajeBytes = mensaje if type (mensaje) == bytes else mensaje.encode ('utf-8')

		# aplicar hash con sal al mensaje
		m = hashA (sal + mensajeBytes, bits)

		# calcular mensaje
		c = composicion_irrestricta (indice=m)
		c[-1] += 1
		c = truncar (c, t)
		g = agrupar (c, grupo)

		# calcular ups, downs
		upsAB = ()
		check = 0
		checkmax = 0
		for n, gn in zip (count (), g):
			ups, downs, maxdowns = calcular_udm (gn, n)
			upsAB += (ups, )
			check += downs
			checkmax += maxdowns

		# agregar check
		c = ceil_raiz (checkmax, split)
		bases = [c + 1] * split
		upsCheck = mixradix (check, bases)

		# calcular ups verificar
		ups_ver = upsCheck + upsAB

		# aplicar ups
		cantidad = len (firma) // upbytes
		f = separar (firma, cantidad)
		test = aplicarUps (f, ups_ver, sal=sal, inicio=False)

		# testear
		valido = (test == pub[0:len (test)])
		return valido

	return verificar


# ----------------------------------------------------------------
if __name__ == '__main__':
	from __crearfuncion_calcular_udm import crearfuncion_calcular_udm

	bits, grupo, t, split = 64, 2, 2, 2
	udA = {(1, 2): (3, 2), (1,): (0, 0), (2,): (1, 1), (2, -2): (7, 0), (2, 1):
		(5, 0), (2, 2): (6, 1), (1, -2): (4, 1), (1, 1): (2, 0)}
	udB = {(1, 2): (1, 3), (-2, 1): (4, 0), (-2, 2): (7, 1), (2, -2): (6, 2), (-2,
		-2): (8, 0), (2, 1): (3, 1), (2, 2): (5, 3), (1, -2): (2, 2), (1, 1): (0, 0)}
	mA = {1: 0, 2: 1, 3: 2, 4: 1}
	mB = {2: 0, 3: 3, 4: 3}
	upbits = 64

	calcular_udm = crearfuncion_calcular_udm (udA, udB, mA, mB)
	verificar = crearfuncion_verificar (bits, grupo, t, split, calcular_udm, upbits)

	pub = '123'
	mensaje = 'abc'
	firma = b'firma invalida'
	sal = b''

	valido = verificar (mensaje, firma=firma, sal=sal, pub=pub)
	print (valido == False)

